-- id-Ϣ finishtype 0ΪѰ·npc 1Ϊָ
local TaskInfo = {
    [1] = { taskname = "Daily Login", taskdesc = "Log into the game once", finsihtype = 0},
    [2] = { taskname = "Chi Study", taskdesc = "Consume 200 Chi Points", finsihtype = 1},
    [3] = { taskname = "Jiang Hu", taskdesc = "Jiang Hu training 5 times", finsihtype = 1},
    [4] = { taskname = "BOSS Kill", taskdesc = "Kill 5 BOSSes", finsihtype = 0},
    [5] = { taskname = "Anima", taskdesc = "Run the Dragon Furnace 1 time", finsihtype = 0},
    [6] = { taskname = "Total Kills", taskdesc = "Kill 1,000 monsters", finsihtype = 0},
    [7] = { taskname = "Qualifier", taskdesc = "Join Qualifier 3 times", finsihtype = 1},
    [8] = { taskname = "Horse Racing", taskdesc = "Join Horse Racing once", finsihtype = 0},
    [9] = { taskname = "Monster Hunter", taskdesc = "Kill 100 Pheasants", finsihtype = 0},
    [10] = { taskname = "Chi Study", taskdesc = "Consume 500 Chi Points", finsihtype = 1},
    [11] = { taskname = "Cumulative Logins", taskdesc = "25 cumulative login days", finsihtype = 0, hide_go = 1},
    [12] = { taskname = "Consecutive Logins", taskdesc = "14 consecutive login days", finsihtype = 0, hide_go = 1},
    [13] = { taskname = "CS CTF", taskdesc = "Compete in CS CTF once", finsihtype = 0},
    [14] = { taskname = "Elite PK", taskdesc = "Compete in Elite PK once", finsihtype = 0},
    [15] = { taskname = "CTF", taskdesc = "Compete in CTF once", finsihtype = 0},
    [16] = { taskname = "Chi Study", taskdesc = "Consume 1,000 Chi Points", finsihtype = 1},
    [17] = { taskname = "BOSS Kill", taskdesc = "Kill 10 BOSSes", finsihtype = 0},
    [18] = { taskname = "Anima", taskdesc = "Run the Dragon Furnace 5 times", finsihtype = 0},
    [19] = { taskname = "PK", taskdesc = "Kill 5 players", finsihtype = 0},
    [20] = { taskname = "CP Credit", taskdesc = "Credit 530 CPs", finsihtype = 1},
    [21] = { taskname = "CP Consumption", taskdesc = "Consume 530 CPs", finsihtype = 1},
    [22] = { taskname = "Mine Cave", taskdesc = "Swap ores 10 times", finsihtype = 0},
    [23] = { taskname = "Perfection", taskdesc = "Temper equipment 10 times", finsihtype = 1},
    [24] = { taskname = "Chi Study", taskdesc = "Consume 5,000 Chi Points", finsihtype = 1},
    [25] = { taskname = "Anima", taskdesc = "Run the Dragon Furnace 10 times", finsihtype = 0},
}

local function GetTaskInfo(idTask, index, default)
    local t = TaskInfo[idTask]
    
    if (t ~= nil) then
        local res = t[index]
        
        if (res ~= nil) then
            return res
        end
    end
    
    return default
end

-- id - 򿪴id
local DlgInfo = {
    [2] = "588",	-- 
    [3] = "619",	-- Դ书
    [7] = "402",	-- λ
    [10] = "588",	-- 
    [16] = "588",	-- 
    [20] = "643",	-- ֵ
    [21] = "436",	-- ʯ
    [23] = "345-2026",	-- 
    [24] = "588",	-- 
}

local function GetDlgInfo(idTask, default)
    local res = DlgInfo[idTask]
    
    if (res ~= nil) then
        return res
    end
    
    return default
end

-- id - Ѱ·Ϣ
local NpcInfo = {
    -- Ǽ
    [0] = {
        [1] = { mapid = 1002, npcid = 9998, x = 275, y = 467},
        [4] = { mapid = 1002, npcid = 9998, x = 275, y = 467},
        [5] = { mapid = 1002, npcid = 23735, x = 348, y = 423},
        [6] = { mapid = 1002, npcid = 0, x = 560, y = 377},
        [8] = { mapid = 1002, npcid = 6001, x = 390, y = 470},
        [9] = { mapid = 1002, npcid = 0, x = 560, y = 377},
        [13] = { mapid = 1002, npcid = 17981, x = 319, y = 323},
        [14] = { mapid = 1002, npcid = 7879, x = 438, y = 270},
        [15] = { mapid = 1002, npcid = 380, x = 319, y = 318},
        [17] = { mapid = 1002, npcid = 9998, x = 275, y = 467},
        [18] = { mapid = 1002, npcid = 23735, x = 348, y = 423},
        [22] = { mapid = 1002, npcid = 23058, x = 339, y = 325},
        [25] = { mapid = 1002, npcid = 23735, x = 348, y = 423},
    },
    
    -- 
    [1] = {
        [1] = { mapid = 10364, npcid = 9998, x = 275, y = 467},
        [4] = { mapid = 10369, npcid = 0, x = 338, y = 268},
        [5] = { mapid = 10364, npcid = 23735, x = 314, y = 292},
        [6] = { mapid = 10364, npcid = 0, x = 408, y = 266},
        [8] = { mapid = 1036, npcid = 6001, x = 284, y = 255},
        [9] = { mapid = 10364, npcid = 0, x = 408, y = 266},
        [13] = { mapid = 10364, npcid = 17981, x = 225, y = 241},
        [14] = { mapid = 10364, npcid = 7879, x = 303, y = 142},
        [15] = { mapid = 10364, npcid = 380, x = 225, y = 238},
        [17] = { mapid = 10369, npcid = 0, x = 338, y = 268},
        [18] = { mapid = 10364, npcid = 23735, x = 314, y = 292},
        [22] = { mapid = 10364, npcid = 23058, x = 321, y = 282},
        [25] = { mapid = 10364, npcid = 23735, x = 314, y = 292},
    },
}

local function GetNpcInfo(isPassion, idTask, nIndex, default)
    local t = NpcInfo[isPassion]
    
    if (t ~= nil) then
        local p = t[idTask]
        
        if (p ~= nil) then
            local res = p[nIndex]
            
            if (res ~= nil) then
                return res
            end
        end
    end
    
    return default
end

local EffectInfo = {
-- spacexּ
    x = 50, y = 200, spacex = -30,
}

local function GetEffectInfo(index, default)
    local res = EffectInfo[index]
    
    if (res ~= nil) then
        return res
    end
    
    return default
end

-- ͷڴ
local function Unload()
    TaskInfo = nil
    DlgInfo = nil
    NpcInfo = nil
    EffectInfo = nil
end

-- ͨrequireLuaűʹ
local BattlePassTask = {
    GetTaskInfo = GetTaskInfo,
    GetDlgInfo = GetDlgInfo,
    GetNpcInfo = GetNpcInfo,
    GetEffectInfo = GetEffectInfo,
    Unload = Unload,
}

-- C++ʹõglobal
BattlePassTask_GetTaskInfo = BattlePassTask.GetTaskInfo
BattlePassTask_GetDlgInfo = BattlePassTask.GetDlgInfo
BattlePassTask_GetNpcInfo = BattlePassTask.GetNpcInfo
BattlePassTask_GetEffectInfo = BattlePassTask.GetEffectInfo
BattlePassTask_Unload = BattlePassTask.Unload

-- requireֵ
return BattlePassTask
